-- get the addon namespace
local addon, ns = ...
-- get the config values
local cfg = ns.cfg
-- holder for some lib functions
local lib = _G["HEDD_lib"] or CreateFrame("Frame","HEDD_lib")
ns.lib = lib

lib.castingtime = function(spellid)
	Hedd_Tooltip = _G["Hedd_Tooltip"] or CreateFrame('GameTooltip', 'Hedd_Tooltip', UIParent, 'GameTooltipTemplate')
	Hedd_Tooltip:SetOwner(UIParent, 'ANCHOR_NONE')
	Hedd_Tooltip:SetSpellByID(spellid)
	text=Hedd_TooltipTextLeft3:GetText()
	Hedd_Tooltip:Hide()
	return hedlib.tofloat(text)
end

lib.GetCastingSpell=function()
	if cfg.casting and cfg.castEnd>cfg.now then
		return cfg.sp_conv[cfg.casting]
	end
	return nil
end

lib.SpellCastingLeft=function(spell)
	if cfg.spells[spell] then
		if cfg.casting==cfg.spells[spell].name and cfg.castEnd>cfg.now then
			return (cfg.castEnd-cfg.now)
		else
			return 0
		end
	else
		if cfg.casting and cfg.castEnd>cfg.now then
			return (cfg.castEnd-cfg.now)
		else
			return 0
		end
	end
end

lib.SpellCasting=function(spell)
	if cfg.spells[spell] then
		if cfg.casting==cfg.spells[spell].name and cfg.castEnd>cfg.now then
			return true, spell
		else
			return nil, cfg.sp_conv[cfg.casting]
		end
	else
		if cfg.casting and cfg.castEnd>cfg.now then
			return true, cfg.sp_conv[cfg.casting]
		else
			return nil
		end
	end
end

lib.ResetCast = function()
	cfg.casting=nil
	cfg.lastspell=nil
	cfg.lastspell2=nil
	cfg.ischanneling=nil
--	cfg.spellcast={}
	cfg.lastspell_time=nil
	spname, _, _, _, startTime, endTime, _, castid = UnitCastingInfo("player")
	if not spname then return end
	cfg.casting=spname
	cfg.castStart=startTime / 1e3
	cfg.castEnd=endTime / 1e3
	cfg.castid=castid
end

lib.UpdateCastStop = function()
	if UnitCastingInfo("player") then return nil end
	cfg.ischanneling=nil
	cfg.casting=nil
	cfg.castid=nil
	cfg.castEnd=cfg.now
end

lib.UpdateCastStart = function(u)
	spname, _, _, _, startTime, endTime, _, castid = UnitCastingInfo(u)
	if not spname then return end
	cfg.casting=spname
	cfg.castStart=startTime / 1e3
	cfg.castEnd=endTime / 1e3
	cfg.castid=castid
end

lib.UpdateCast = function(u)
	spname, _, _, _, startTime, endTime, _, castid = UnitCastingInfo(u)
	if not spname then
		cfg.ischanneling=nil
		cfg.casting=nil
		cfg.castid=nil
		cfg.castEnd=cfg.now
		return
		end
--	if not startTime then return end
	cfg.casting=spname
	cfg.castStart=startTime / 1e3
	cfg.castEnd=endTime / 1e3
	cfg.castid=castid
end

lib.SaveSpell = function(spellID)
	cfg.spellcast[spellID]=cfg.now
	cfg.lastspell2=cfg.lastspell
	cfg.lastspell=spellID
	cfg.lastspell_time=cfg.now
end

lib.IsLastSpell = function(spell)
	if cfg.lastspell and cfg.spells[spell] and cfg.lastspell==cfg.spells[spell].id then
		return true
	end
	return nil
end

lib.GetLastCast = function(spellID)
	if cfg.spellcast[spellID] then return (cfg.now-cfg.spellcast[spellID]) end
	return 99999
end

lib.GetLastSpell = function (spells)
	for _,cspell in ipairs(spells) do
		if cfg.spells[cspell] and cfg.spellcast[cfg.spells[cspell].id] then
			if cfg.now<(cfg.spellcast[cfg.spells[cspell].id]-cfg.spells[cspell].castingTime+1) then
				return true
			end
		end
	end
	return nil
end

lib.GetLast2Spell = function (spells)
	for index,spell in ipairs(spells) do
		if cfg.spells[spell] and cfg.lastspell2==cfg.spells[spell].name then
			return true
		end
	end
	return nil
end